﻿// テキスレイヤー内にある金額に消費税を適用する
// ただし、ロックされているレイヤーは対象外。サブレイヤーも対象外
(function(){
    var oldTax = prompt("現在の税金を入れてください(5%なら5)", 5);
    if (!oldTax){ return; }
    var newTax = prompt("新たな税金を入れて下さい(10%なら10)", 10);
    if (!newTax){ return; }
    oldTax = oldTax / 100;
    newTax = newTax/100;
    var pricePat = new RegExp("(0|[1-9][0-9]{0,2}(,[0-9]{3}){0,2})円$", "g");
    var layObj = app.activeDocument.layers;
    for(var i=0; i<layObj.length; i++){
        if (layObj[i].kind != LayerKind.TEXT){ continue; }  // テキストレイヤー以外は処理しない
        if (layObj[i].allLocked == true){ continue; }  // Allロックされている場合は処理しない
        layObj[i].textItem.contents = layObj[i].textItem.contents.replace(pricePat,
            function(str, ptr, allStr){
                var p = parseInt(str.split(",").join(""));  // 数値に変換
                var price = p / (1 + oldTax);
                var newPrice = Math.floor(price * (1+newTax));
                $.writeln("元金額："+price+"、元の税込み金額："+p+"、新価格："+newPrice);
                newPrice = num3Format(newPrice);
                return newPrice + "円";
        });
    }
})();
function num3Format(str){   // 3桁に区切る
    var temp1 = (new String(str)).split(".")[0].match(/./g).reverse().join("");
    temp1 = temp1.replace(/(\d{3})/g,"$1,");
    temp1 = temp1.match(/./g).reverse().join("").replace(/^,/,"");
    if(!!(new String(str)).split(".")[1]) temp1 = temp1 +"."+ str.split(".")[1];
    return temp1;
}