﻿// テキスレイヤー内にある金額が範囲内か調べる
// ただし、ロックされているレイヤーは対象外。サブレイヤーも対象外
(function(){
    var min = prompt("最低価格（含む）を入れてください", 100);
    if (!min){ return; }
    var max = prompt("最高価格（含む）を入れて下さい", 9999);
    if (!max){ return; }
    min = parseInt(min);    // 小数値以下は切り捨て
    max = parseInt(max);
    var pricePat = new RegExp("(0|[1-9][0-9]{0,2}(,[0-9]{3}){0,2})円$", "g");
    var layObj = app.activeDocument.layers;
    for(var i=0; i<layObj.length; i++){
        if (layObj[i].kind != LayerKind.TEXT){ continue; }  // テキストレイヤー以外は処理しない
        if (layObj[i].allLocked == true){ continue; }  // Allロックされている場合は処理しない
        layObj[i].textItem.contents.replace(pricePat, function(str, ptr, allStr){
            var p = parseInt(str.split(",").join(""));  // 数値に変換
            $.writeln(p+", "+(p >= min) && (p <= max));
            if ((p >= min) && (p <= max)){ return str; }
            alert("金額が範囲外です。"+p+"円");
            i = layObj.length+ 1;   // ループ脱出のために設定
            return str;
        });
    }
})();
